/* Copyright (C) 1994 Massachusetts Institute of Technology, Cambridge, MA */
/* All rights reserved */

/* prax_xm.h */

#ifndef PRAX_XM_H
#define PRAX_XM_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

/* menu item structure */

typedef struct menuItemTag {
  char		*label;		/* menu label */
  WidgetClass	*wclass;	/* widget class */
  char		mnemonic;	/* mnemonic character */
  char		*accelerator;	/* accelerator character */
  char		*accelText;	/* accelerator text */
  void		(*callback)();	/* callback function */
  XtPointer	callbackData;	/* extra data */
  struct menuItemTag *subitems;	/* sub-menu */
} MenuItem;

void	AboutCB(Widget, XtPointer, XtPointer);
void	AllCB(Widget, XtPointer, XtPointer);
void	AlphaFacetCB(Widget, XtPointer, XtPointer);
void	ApproxCurvCB(Widget, int, XtPointer);
void	ApproxSurfCB(Widget, int, XtPointer);
void	AutoInspectCB(Widget, XtPointer, XtPointer);
void	BackgroundCB(Widget, XtPointer, XtPointer);
void	BlendSurfCB(Widget, XtPointer, XtPointer);
void	BsplineToBezierCurvCB(Widget, XtPointer, XtPointer);
void	BsplineToBezierSurfCB(Widget, XtPointer, XtPointer);
Widget	BuildMenu(Widget, int, char *, char, MenuItem *);
void	CamberLineCB(Widget, XtPointer, XtPointer);
void	CamberSurfCB(Widget, XtPointer, XtPointer);
void	CancelCB(Widget, XtPointer, XtPointer);
void	CheckBox(char *, char *, int, char *[], int [], int [], int *);
void	CheckBoxToggleCB(Widget, XtPointer, XtPointer);
void    CheckpointLogCB(Widget, XtPointer, XtPointer);
void	ColorPostScriptCB(Widget, XtPointer, XtPointer);
void    CompareConvexCB(Widget, int, XtPointer);
void	ConstraineBladeCB(Widget, XtPointer, XtPointer);
void	ConstrainedCB(Widget, XtPointer, XtPointer);
void	ContinuityCB(Widget, int, XtPointer);
void	ContinuityCheckCB(Widget, int, XtPointer);
void	ContourCB(Widget, XtPointer, XtPointer);
void	ContourFacet2CB(Widget, XtPointer, XtPointer);
void	ContourFacetsCB(Widget, XtPointer, XtPointer);
void    ConvertNonOpenCB(Widget, XtPointer, XtPointer);
void	CopyCB(Widget, int, XtPointer);
void	CosColorCB(Widget, XtPointer, XtPointer);
void	CosEvaluateCB(Widget, XtPointer, XtPointer);
void    CosEvaluateFileCB(Widget, XtPointer, XtPointer);
void	CosEvaluateScaleCB(Widget, XtPointer, XtPointer);
void	CosEvaluateTCB(Widget, XtPointer, XtPointer);
void	CosFocalCB(Widget, XtPointer, XtPointer);
void	CosFocalMaxCB(Widget, XtPointer, XtPointer);
void	CosFocalMinCB(Widget, XtPointer, XtPointer);
void	CosFocalScaleCB(Widget, XtPointer, XtPointer);
void	CosKnotsCB(Widget, XtPointer, XtPointer);
void	CosPolygonCB(Widget, XtPointer, XtPointer);
void	CosPorcupineCB(Widget, XtPointer, XtPointer);
void	CosPorcupineMaxCB(Widget, XtPointer, XtPointer);
void	CosPorcupineMinCB(Widget, XtPointer, XtPointer);
void	CosPorcupineScaleCB(Widget, XtPointer, XtPointer);
void	CosSegmentsCB(Widget, XtPointer, XtPointer);
void	CosSelfCB(Widget, XtPointer, XtPointer);
void	CosSurfaceCB(Widget, XtPointer, XtPointer);
void	CosToCurvCB(Widget, XtPointer, XtPointer);
Widget	CreateContourWindow(Widget);
void	CreateCursors(Display *);
Widget	CreateGlxWindow(Widget);
Widget	CreateMenuBar(Widget);
Widget	CreateToolBar(Widget);
Widget	CreateUvSpace(Widget);
Widget	CreateViewPad(Widget);
Widget	CreateViewWindow(Widget);
void	CurvColorCB(Widget, XtPointer, XtPointer call_data);
void	CurvEvaluateCB(Widget, XtPointer, XtPointer);
void    CurvEvaluateFileCB(Widget, XtPointer, XtPointer);
void	CurvEvaluateScaleCB(Widget, XtPointer, XtPointer);
void	CurvEvaluateTCB(Widget, XtPointer, XtPointer);
void	CurvFocalCB(Widget, XtPointer, XtPointer);
void	CurvFocalScaleCB(Widget, XtPointer, XtPointer);
void	CurvKnotsCB(Widget, XtPointer, XtPointer);
void    CurvOffsetCB(Widget, XtPointer, XtPointer);
void    CurvOffsetDistCB(Widget, XtPointer, XtPointer);
void	CurvOrthoCB(Widget, XtPointer, XtPointer);
void	CurvOrthoPxCB(Widget, XtPointer, XtPointer);
void	CurvOrthoPyCB(Widget, XtPointer, XtPointer);
void	CurvOrthoPzCB(Widget, XtPointer, XtPointer);
void	CurvOrthoScaleCB(Widget, XtPointer, XtPointer);
void	CurvPolygonCB(Widget, XtPointer, XtPointer);
void	CurvPorcupineCB(Widget, XtPointer, XtPointer);
void	CurvPorcupineScaleCB(Widget, XtPointer, XtPointer);
void	CurvRadialCB(Widget, XtPointer, XtPointer);
void	CurvRadialPxCB(Widget, XtPointer, XtPointer);
void	CurvRadialPyCB(Widget, XtPointer, XtPointer);
void	CurvRadialPzCB(Widget, XtPointer, XtPointer);
void	CurvRadialScaleCB(Widget, XtPointer, XtPointer);
void	CurvSegmentsCB(Widget, XtPointer, XtPointer);
void	CurvSelfCB(Widget, XtPointer, XtPointer);
void	CurvTorsionCB(Widget, XtPointer, XtPointer);
void	CurvTorsionScaleCB(Widget, XtPointer, XtPointer);
void	DefaultIgesEntityCB(Widget, XtPointer, XtPointer);
void	DeleteCB(Widget, int, XtPointer);
void	DeleteCursors(Display *display);
void	DeviationCB(Widget, XtPointer, XtPointer);
void	DistFacetCB(Widget, XtPointer, XtPointer);
void    EditContinuityCB(Widget, int, XtPointer);
Widget  EditContinuitySurf(char *, char *);
void    EditContSurfCB(Widget, XtPointer, XtPointer);
void    EditContSurfFileCB(Widget, XtPointer, XtPointer);
void    EditContSurfOkCB(Widget, XtPointer, XtPointer);
void    EditContSurfScaleCB(Widget, XtPointer, XtPointer);
void	EditKnotsCB(Widget, int, XtPointer);
void	EditUvCB(Widget, XtPointer, XtPointer);
Widget	EntityProperties(short, char *, char *_of, char *, int,
		int, int, int, float *, long, void *);
void	EvalCosOkCB(Widget, XtPointer, XtPointer);
void	EvalCurvOkCB(Widget, XtPointer, XtPointer);
void	EvalFacetOkCB(Widget, XtPointer, XtPointer);
void	EvalSurfOkCB(Widget, XtPointer, XtPointer);
void	EvalTrimOkCB(Widget, XtPointer, XtPointer);
void	EvaluateCB(Widget, int, XtPointer);
void	FacetCB(Widget, XtPointer, XtPointer);
void    FacetToEdgeCB(Widget, XtPointer, XtPointer);
void	FacetColorCB(Widget, XtPointer, XtPointer);
void	FacetContourScaleCB(Widget, XtPointer, XtPointer);
void	FacetCubicCB(Widget, XtPointer, XtPointer);
void	FacetDiscreteCB(Widget, XtPointer, XtPointer);
void	FacetEvaluateCB(Widget, XtPointer, XtPointer);
void    FacetEvaluateFileCB(Widget, XtPointer, XtPointer);
void	FacetEvaluateScaleXCB(Widget, XtPointer, XtPointer);
void	FacetEvaluateScaleYCB(Widget, XtPointer, XtPointer);
void	FacetEvaluateXCB(Widget, XtPointer, XtPointer);
void	FacetEvaluateYCB(Widget, XtPointer, XtPointer);
void	FacetHeightCB(Widget, XtPointer, XtPointer);
void	FacetHeightXCB(Widget, XtPointer, XtPointer);
void	FacetHeightYCB(Widget, XtPointer, XtPointer);
void	FacetHeightZCB(Widget, XtPointer, XtPointer);
void	FacetHullCB(Widget, XtPointer, XtPointer);
void	FacetLinearCB(Widget, XtPointer, XtPointer);
void	FacetMapToSurfaceCB(Widget, XtPointer, XtPointer);
void	FacetMaxContourCB(Widget, XtPointer, XtPointer);
void	FacetMinContourCB(Widget, XtPointer, XtPointer);
void	FacetQuadraticCB(Widget, XtPointer, XtPointer);
void	FacetQuarticCB(Widget, XtPointer, XtPointer);
void	FacetQuinticCB(Widget, XtPointer, XtPointer);
void	FacetRangeCB(Widget, XtPointer, XtPointer);
void	FacetScaleExposeCB(Widget, XtPointer, XtPointer);
void	FacetScaleInitCB(Widget, XtPointer, XtPointer);
void	FacetSelfCB(Widget, XtPointer, XtPointer);
void	FacetShadedCB(Widget, XtPointer, XtPointer);
void	FacetSlopeCB(Widget, XtPointer, XtPointer);
void	FacetSlopeNCB(Widget, XtPointer, XtPointer);
void	FacetSlopeUCB(Widget, XtPointer, XtPointer);
void	FacetSlopeVCB(Widget, XtPointer, XtPointer);
void 	FacetSurfaceCB(Widget, XtPointer, XtPointer);
void	FacetWireframeCB(Widget, XtPointer, XtPointer);
void	FairCancelCB(Widget, XtPointer, XtPointer);
void	FairingCB(Widget, int, XtPointer);
void	FairOkCB(Widget, XtPointer, XtPointer);
void	FairUndoCB(Widget, XtPointer, XtPointer);
void    FileBoxOkCB(Widget, XtPointer, XtPointer);
void	FilterCB(Widget, XtPointer, XtPointer);
void	FitCosCB(Widget, int, XtPointer);
void	FitCurvCB(Widget, int, XtPointer);
void	FitSurfCB(Widget, int, XtPointer);
void	FormatCB(Widget, XtPointer, XtPointer);
void	GenCylCB(Widget, XtPointer, XtPointer);
XtAppContext GetAppContext(void);
Display *GetDisplay(void);
Widget	GetGlxWindow(void);
Widget	GetMenuBar(void);
Widget	GetToolBar(void);
Widget	GetTopLevel(void);
Widget	GetViewPad(void);
Widget	GetViewingAxis(void);
void	GlxExposeCB(Widget, XtPointer, XtPointer);
void	GlxGinitCB(Widget, XtPointer, XtPointer);
void	GlxInputCB(Widget, XtPointer, XtPointer);
void	GlxResizeCB(Widget, XtPointer, XtPointer);
void	GridColorCB(Widget, XtPointer, XtPointer);
void	GridContourScaleCB(Widget, XtPointer, XtPointer);
void	GridCubicCB(Widget, XtPointer, XtPointer);
void	GridDiscreteCB(Widget, XtPointer, XtPointer);
void	GridHeightCB(Widget, XtPointer, XtPointer);
void	GridHeightXCB(Widget, XtPointer, XtPointer);
void	GridHeightYCB(Widget, XtPointer, XtPointer);
void	GridHeightZCB(Widget, XtPointer, XtPointer);
void	GridLinearCB(Widget, XtPointer, XtPointer);
void	GridMaxContourCB(Widget, XtPointer, XtPointer);
void	GridMinContourCB(Widget, XtPointer, XtPointer);
void	GridPolygonCB(Widget, XtPointer, XtPointer);
void	GridRangeCB(Widget, XtPointer, XtPointer);
void	GridQuadraticCB(Widget, XtPointer, XtPointer);
void	GridQuarticCB(Widget, XtPointer, XtPointer);
void	GridQuinticCB(Widget, XtPointer, XtPointer);
void	GridScaleExposeCB(Widget, XtPointer, XtPointer);
void	GridScaleInitCB(Widget, XtPointer, XtPointer);
void	GridSelfCB(Widget, XtPointer, XtPointer);
void	GridToListCB(Widget, XtPointer, XtPointer);
void	GridWireframeCB(Widget, XtPointer, XtPointer);
void	GroupAbsoluteCB(Widget, XtPointer, XtPointer);
void	GroupColorCB(Widget, XtPointer, XtPointer);
void	GroupContourScaleCB(Widget, XtPointer, XtPointer);
void	GroupCubicCB(Widget, XtPointer, XtPointer);
void	GroupCurvatureCB(Widget, XtPointer, XtPointer);
void	GroupDiscreteCB(Widget, XtPointer, XtPointer);
void	GroupGaussianCB(Widget, XtPointer, XtPointer);
void	GroupHeightCB(Widget, XtPointer, XtPointer);
void	GroupHeightXCB(Widget, XtPointer, XtPointer);
void	GroupHeightYCB(Widget, XtPointer, XtPointer);
void	GroupHeightZCB(Widget, XtPointer, XtPointer);
void	GroupLinearCB(Widget, XtPointer, XtPointer);
void	GroupMapToSurfaceCB(Widget, XtPointer, XtPointer);
void	GroupMaxContourCB(Widget, XtPointer, XtPointer);
void	GroupMaxPrincipalCB(Widget, XtPointer, XtPointer);
void	GroupMaxRadiiCB(Widget, XtPointer, XtPointer);
void	GroupMeanCB(Widget, XtPointer, XtPointer);
void	GroupMinContourCB(Widget, XtPointer, XtPointer);
void	GroupMinDistCB(Widget, XtPointer, XtPointer);
void	GroupMinPrincipalCB(Widget, XtPointer, XtPointer);
void	GroupMinRadiiCB(Widget, XtPointer, XtPointer);
void	GroupNormalUCB(Widget, XtPointer, XtPointer);
void	GroupNormalVCB(Widget, XtPointer, XtPointer);
void	GroupOrdinalCB(Widget, XtPointer, XtPointer);
void	GroupQuadraticCB(Widget, XtPointer, XtPointer);
void	GroupQuarticCB(Widget, XtPointer, XtPointer);
void	GroupQuinticCB(Widget, XtPointer, XtPointer);
void	GroupRangeCB(Widget, XtPointer, XtPointer);
void	GroupRmsCB(Widget, XtPointer, XtPointer);
void	GroupScaleExposeCB(Widget, XtPointer, XtPointer);
void	GroupScaleInitCB(Widget, XtPointer, XtPointer);
void	GroupShadedCB(Widget, XtPointer, XtPointer);
void	GroupSlopeCB(Widget, XtPointer, XtPointer);
void	GroupSlopeNCB(Widget, XtPointer, XtPointer);
void	GroupSlopeUCB(Widget, XtPointer, XtPointer);
void	GroupSlopeVCB(Widget, XtPointer, XtPointer);
void	GroupTwoSidedCB(Widget, XtPointer, XtPointer);
void	GroupWireframeCB(Widget, XtPointer, XtPointer);
void	HelpCB(Widget, XtPointer, XtPointer);
void	HostCB(Widget, XtPointer, XtPointer);
void	HullColorCB(Widget, XtPointer, XtPointer);
void	HullNonConvexCB(Widget, XtPointer, XtPointer);
void	HullWireframeCB(Widget, XtPointer, XtPointer);
void	HullShadedCB(Widget, XtPointer, XtPointer);
void    ImagePostScriptCB(Widget, XtPointer, XtPointer);
void    InspColorCB(Widget, XtPointer, XtPointer);
void    InspNormalScaleCB(Widget, XtPointer, XtPointer);
void    InspPolygonCB(Widget, XtPointer, XtPointer);
void    InspSelfCB(Widget, XtPointer, XtPointer);
void	InspectPtsCB(Widget, XtPointer, XtPointer);
void    InspectTrimCB(Widget, XtPointer, XtPointer);
void	InstallColormap(Widget, Widget);
void	InterrCosOkCB(Widget, XtPointer, XtPointer);
void	InterrCurvOkCB(Widget, XtPointer, XtPointer);
void	InterrFacetOkCB(Widget, XtPointer, XtPointer);
void	InterrGridOkCB(Widget, XtPointer, XtPointer);
void	InterrGroupOkCB(Widget, XtPointer, XtPointer);
void	InterrGroupUpdateCB(Widget, XtPointer, XtPointer);
void	InterrHullOkCB(Widget, XtPointer, XtPointer);
void	InterrInspOkCB(Widget, XtPointer, XtPointer);
void	InterrListOkCB(Widget, XtPointer, XtPointer);
void	InterrSurfOkCB(Widget, XtPointer, XtPointer);
void	InterrTrimOkCB(Widget, XtPointer, XtPointer);
void	InterrUvOkCB(Widget, XtPointer, XtPointer);
void	InterrogateCB(Widget, int, XtPointer);
void    InvertTrimCB(Widget, XtPointer, XtPointer);
void	IsoCurvCB(Widget, int, XtPointer);
void	JoinCB(Widget, int, XtPointer);
void	LeadingEdgeCosCB(Widget, int, XtPointer);
void	LeadingEdgeCurvCB(Widget, int, XtPointer);
void	ListColorCB(Widget, XtPointer, XtPointer);
void	ListContourScaleCB(Widget, XtPointer, XtPointer);
void	ListCubicCB(Widget, XtPointer,	XtPointer);
void	ListDiscreteCB(Widget, XtPointer, XtPointer);
void	ListHeightCB(Widget, XtPointer, XtPointer);
void	ListHeightXCB(Widget, XtPointer, XtPointer);
void	ListHeightYCB(Widget, XtPointer, XtPointer);
void	ListHeightZCB(Widget, XtPointer, XtPointer);
void	ListLinearCB(Widget, XtPointer, XtPointer);
void	ListMaxContourCB(Widget, XtPointer, XtPointer);
void	ListMinContourCB(Widget, XtPointer, XtPointer);
void	ListMinDistCB(Widget, XtPointer, XtPointer);
void	ListMinNoTolerCB(Widget, XtPointer, XtPointer);
void	ListMinNoTolerSignedCB(Widget, XtPointer, XtPointer);
void	ListMinProjCB(Widget, XtPointer, XtPointer);
void	ListMinSignedCB(Widget, XtPointer,  XtPointer);
void	ListMinTolerCB(Widget, XtPointer, XtPointer);
void	ListMinUnsignedCB(Widget, XtPointer, XtPointer);
void	ListOrdinalCB(Widget, XtPointer, XtPointer);
void	ListPolygonCB(Widget, XtPointer, XtPointer);
void	ListRangeCB(Widget, XtPointer, XtPointer);
void	ListQuadraticCB(Widget, XtPointer, XtPointer);
void	ListQuarticCB(Widget, XtPointer, XtPointer);
void	ListQuinticCB(Widget, XtPointer, XtPointer);
void	ListScaleExposeCB(Widget, XtPointer, XtPointer);
void	ListScaleInitCB(Widget, XtPointer, XtPointer);
void	ListSelfCB(Widget, XtPointer, XtPointer);
void	ListToUvPtsCB(Widget, XtPointer, XtPointer);
void	ListWireframeCB(Widget, XtPointer, XtPointer);
void	LoftSurfCB(Widget, XtPointer, XtPointer);
Boolean	LogoProcedure(XtPointer data);
void	MeasuredPointsCB(Widget, XtPointer, XtPointer);
void	MemoryCB(Widget, XtPointer, XtPointer);
void	MinDistanceCB(Widget, XtPointer, XtPointer);
void	MinDistCurvCB(Widget, XtPointer, XtPointer);
void	MinDistToListCB(Widget, XtPointer, XtPointer);
void    MinDistTrimCB(Widget, XtPointer, XtPointer);
void	MotdCB(Widget w, XtPointer, XtPointer);
void    MultiFloatButtonCB(Widget, XtPointer, XtPointer);
void	NewGroupCB(Widget, XtPointer, XtPointer);
void	NotOkCB(Widget, XtPointer, XtPointer);
void	OffsetCosCB(Widget, XtPointer, XtPointer);
void	OffsetCurvCB(Widget, XtPointer, XtPointer);
void	OffsetCurv2dCB(Widget, XtPointer, XtPointer);
void	OffsetSurfCB(Widget, XtPointer, XtPointer);
void	OkCB(Widget, XtPointer, XtPointer);
void	OkMotdCB(Widget, XtPointer, XtPointer);
void	OpenCB(Widget, int, XtPointer);
void	OpenIgesCB(Widget, XtPointer, XtPointer);
void	OpenLocalCB(Widget, XtPointer, XtPointer);
void	OpenLocalFileCB(Widget w, XtPointer, XtPointer);
void	OpenMinDistCB(Widget, XtPointer, XtPointer);
void	OpenMinDistFileCB(Widget, XtPointer, XtPointer);
void	OpenScriptCB(Widget, XtPointer, XtPointer);
void	OrthoDistanceCB(Widget, XtPointer, XtPointer);
void	OrthoProjCosCB(Widget, int, XtPointer);
void	OrthoProjCurvCB(Widget, int, XtPointer);
void	OverrideCB(Widget, XtPointer, XtPointer);
Widget  PaneBox(char *, char *, int, char **,
		void (*)(Widget, XtPointer, XtPointer), void *);
void	PrimitiveCurvCB(Widget, int, XtPointer);
void	PrimitiveSurfCB(Widget, int, XtPointer);
void	ProbeRadiusCB(Widget, XtPointer, XtPointer);
void	PropCosOkCB(Widget, XtPointer, XtPointer);
void	PropCurvOkCB(Widget, XtPointer, XtPointer);
void	PropertiesCB(Widget, int, XtPointer);
void	PropFacetOkCB(Widget, XtPointer, XtPointer);
void	PropGridOkCB(Widget, XtPointer, XtPointer);
void	PropGroupOkCB(Widget, XtPointer, XtPointer);
void	PropHullOkCB(Widget, XtPointer, XtPointer);
void	PropInspOkCB(Widget, XtPointer, XtPointer);
void	PropListOkCB(Widget, XtPointer, XtPointer);
void	PropSurfOkCB(Widget, XtPointer, XtPointer);
void	PropTrimOkCB(Widget, XtPointer, XtPointer);
void	PropUvOkCB(Widget, XtPointer, XtPointer);
void	PropVectOkCB(Widget, XtPointer, XtPointer);
void	QuitCB(Widget, XtPointer, XtPointer);
void	RadioBoxToggleCB(Widget, XtPointer, XtPointer);
void	RadiusToleranceCB(Widget, XtPointer, XtPointer);
Boolean ReadScriptFile(XtPointer);
void	ReflectCB(Widget, int, XtPointer);
void	RevContourCB(Widget, XtPointer, XtPointer);
void	RevParamCB(Widget, int, XtPointer);
void    RobustCurvCB(Widget, XtPointer, XtPointer);
void    RobustDistCB(Widget, XtPointer, XtPointer);
void	RuledSurfCB(Widget, XtPointer, XtPointer);
void	SampleCurvCB(Widget, XtPointer, XtPointer);
void	SampleFacetGridCB(Widget, XtPointer, XtPointer);
void	SampleSizeCB(Widget, XtPointer, XtPointer);
void	SampleSurfGridCB(Widget, XtPointer, XtPointer);
void	SampleSurfListCB(Widget, XtPointer, XtPointer);
void	SaveCB(Widget, int, XtPointer);
void	SaveIgesCB(Widget, int, XtPointer);
void	SaveIgesMinDistCB(Widget, XtPointer, XtPointer);
void	SaveLocalCB(Widget, XtPointer, XtPointer);
void	SaveMinDistCB(Widget, XtPointer, XtPointer);
void	SavePostScriptCB(Widget, XtPointer, XtPointer);
void	ScatteredSurfCB(Widget, XtPointer, XtPointer);
void	SelectCB(Widget, int, XtPointer);
void	SelectGroupCB(Widget, XtPointer, XtPointer);
void	SetColorButton(Widget, long);
void	SetCursor(Display *, Window, short);
void	SetZeroCB(Widget, XtPointer, XtPointer);
void	SplitCB(Widget, XtPointer, XtPointer);
void	SplitSurfCancelCB(Widget, XtPointer, XtPointer);
void	SplitSurfOkCB(Widget, XtPointer, XtPointer);
void    StitchFacetCB(Widget, XtPointer, XtPointer);
void	SubDistanceCB(Widget, XtPointer, XtPointer);
void	SubdivideCB(Widget, int, XtPointer);
void	SurfAbsoluteCB(Widget, XtPointer, XtPointer);
void	SurfAdaptiveCB(Widget, XtPointer, XtPointer);
void	SurfColorCB(Widget, XtPointer, XtPointer);
void	SurfContourScaleCB(Widget, XtPointer, XtPointer);
void	SurfCubicCB(Widget, XtPointer,	XtPointer);
void	SurfCurvatureCB(Widget, XtPointer, XtPointer);
void	SurfDiscreteCB(Widget, XtPointer, XtPointer);
void	SurfEvaluateCB(Widget, XtPointer, XtPointer);
void    SurfEvaluateFileCB(Widget, XtPointer, XtPointer);
void	SurfEvaluateScaleUCB(Widget, XtPointer, XtPointer);
void	SurfEvaluateScaleVCB(Widget, XtPointer, XtPointer);
void	SurfEvaluateUCB(Widget, XtPointer, XtPointer);
void	SurfEvaluateVCB(Widget, XtPointer, XtPointer);
void	SurfFocalCB(Widget, XtPointer,	XtPointer);
void	SurfFocalMaxCB(Widget, XtPointer, XtPointer);
void	SurfFocalMinCB(Widget, XtPointer, XtPointer);
void	SurfFocalScaleCB(Widget, XtPointer, XtPointer);
void	SurfGaussianCB(Widget, XtPointer, XtPointer);
void	SurfHeightCB(Widget, XtPointer, XtPointer);
void	SurfHeightXCB(Widget, XtPointer, XtPointer);
void	SurfHeightYCB(Widget, XtPointer, XtPointer);
void	SurfHeightZCB(Widget, XtPointer, XtPointer);
void	SurfIntersectCB(Widget, XtPointer, XtPointer);
void	SurfKnotsCB(Widget, XtPointer, XtPointer);
void	SurfLinearCB(Widget, XtPointer, XtPointer);
void	SurfMaxContourCB(Widget, XtPointer, XtPointer);
void	SurfMaxPrincipalCB(Widget, XtPointer, XtPointer);
void	SurfMaxRadiiCB(Widget, XtPointer, XtPointer);
void	SurfMeanCB(Widget, XtPointer, XtPointer);
void	SurfMinContourCB(Widget, XtPointer, XtPointer);
void	SurfMinPrincipalCB(Widget, XtPointer, XtPointer);
void	SurfMinRadiiCB(Widget, XtPointer, XtPointer);
void	SurfNormalUCB(Widget, XtPointer, XtPointer);
void	SurfNormalVCB(Widget, XtPointer, XtPointer);
void	SurfOffsetCB(Widget, XtPointer, XtPointer);
void	SurfOffsetDistCB(Widget, XtPointer, XtPointer);
void	SurfOffsetOneCB(Widget, XtPointer, XtPointer);
void	SurfOffsetTwoCB(Widget, XtPointer, XtPointer);
void	SurfOrthoCB(Widget, XtPointer, XtPointer);
void	SurfOrthoPxCB(Widget, XtPointer, XtPointer);
void	SurfOrthoPyCB(Widget, XtPointer, XtPointer);
void	SurfOrthoPzCB(Widget, XtPointer, XtPointer);
void	SurfOrthoScaleCB(Widget, XtPointer, XtPointer);
void	SurfPivotCB(Widget, XtPointer, XtPointer);
void	SurfPivotFileCB(Widget, XtPointer, XtPointer);
void	SurfPivotScaleCB(Widget, XtPointer, XtPointer);
void	SurfPivotValueCB(Widget, XtPointer, XtPointer);
void	SurfScaleExposeCB(Widget, XtPointer, XtPointer);
void	SurfScaleInitCB(Widget, XtPointer, XtPointer);
void	SurfPolygonCB(Widget, XtPointer, XtPointer);
void	SurfQuadraticCB(Widget, XtPointer, XtPointer);
void	SurfQuarticCB(Widget, XtPointer, XtPointer);
void	SurfQuinticCB(Widget, XtPointer, XtPointer);
void	SurfRangeCB(Widget, XtPointer, XtPointer);
void	SurfRmsCB(Widget, XtPointer, XtPointer);
void	SurfSegmentUCB(Widget, XtPointer, XtPointer);
void	SurfSegmentVCB(Widget, XtPointer, XtPointer);
void	SurfSelfCB(Widget, XtPointer, XtPointer);
void	SurfShadedCB(Widget, XtPointer, XtPointer);
void	SurfSplitAddUCB(Widget, XtPointer, XtPointer);
void	SurfSplitAddVCB(Widget, XtPointer, XtPointer);
void	SurfSplitRemoveUCB(Widget, XtPointer, XtPointer);
void	SurfSplitRemoveVCB(Widget, XtPointer, XtPointer);
void	SurfSplitScaleUCB(Widget, XtPointer, XtPointer);
void	SurfSplitScaleVCB(Widget, XtPointer, XtPointer);
void	SurfSplitUCB(Widget, XtPointer, XtPointer);
void	SurfSplitVCB(Widget, XtPointer, XtPointer);
void	SurfSubSegmentUCB(Widget, XtPointer, XtPointer);
void	SurfSubSegmentVCB(Widget, XtPointer, XtPointer);
void	SurfTwoSidedCB(Widget, XtPointer, XtPointer);
void	SurfUniformCB(Widget, XtPointer, XtPointer);
void	SurfWireframeCB(Widget, XtPointer, XtPointer);
void	ToleranceRegionCB(Widget, XtPointer, XtPointer);
void	ToolBarCB(Widget, XtPointer, XtPointer);
void	TransformCB(Widget, int, XtPointer);
void	TrimAbsoluteCB(Widget, XtPointer, XtPointer);
void	TrimColorCB(Widget, XtPointer, XtPointer);
void	TrimConstrainedCB(Widget, XtPointer, XtPointer);
void	TrimContourScaleCB(Widget, XtPointer, XtPointer);
void	TrimCubicCB(Widget, XtPointer,	XtPointer);
void	TrimCurvatureCB(Widget, XtPointer, XtPointer);
void	TrimDiscreteCB(Widget, XtPointer, XtPointer);
void	TrimEvaluateCB(Widget, XtPointer, XtPointer);
void    TrimEvaluateFileCB(Widget, XtPointer, XtPointer);
void	TrimEvaluateScaleUCB(Widget, XtPointer, XtPointer);
void	TrimEvaluateScaleVCB(Widget, XtPointer, XtPointer);
void	TrimEvaluateUCB(Widget, XtPointer, XtPointer);
void	TrimEvaluateVCB(Widget, XtPointer, XtPointer);
void	TrimFocalCB(Widget, XtPointer, XtPointer);
void	TrimFocalMaxCB(Widget, XtPointer, XtPointer);
void	TrimFocalMinCB(Widget, XtPointer, XtPointer);
void	TrimFocalScaleCB(Widget, XtPointer, XtPointer);
void	TrimGaussianCB(Widget, XtPointer, XtPointer);
void	TrimHeightCB(Widget, XtPointer, XtPointer);
void	TrimHeightXCB(Widget, XtPointer, XtPointer);
void	TrimHeightYCB(Widget, XtPointer, XtPointer);
void	TrimHeightZCB(Widget, XtPointer, XtPointer);
void	TrimLinearCB(Widget, XtPointer, XtPointer);
void	TrimMaxContourCB(Widget, XtPointer, XtPointer);
void	TrimMaxPrincipalCB(Widget, XtPointer, XtPointer);
void	TrimMaxRadiiCB(Widget, XtPointer, XtPointer);
void	TrimMeanCB(Widget, XtPointer, XtPointer);
void	TrimMinContourCB(Widget, XtPointer, XtPointer);
void	TrimMinPrincipalCB(Widget, XtPointer, XtPointer);
void	TrimMinRadiiCB(Widget, XtPointer, XtPointer);
void	TrimNormalUCB(Widget, XtPointer, XtPointer);
void	TrimNormalVCB(Widget, XtPointer, XtPointer);
void	TrimOffsetCB(Widget, XtPointer, XtPointer);
void	TrimOffsetDistCB(Widget, XtPointer, XtPointer);
void	TrimOrthoCB(Widget, XtPointer, XtPointer);
void	TrimOrthoPxCB(Widget, XtPointer, XtPointer);
void	TrimOrthoPyCB(Widget, XtPointer, XtPointer);
void	TrimOrthoPzCB(Widget, XtPointer, XtPointer);
void	TrimOrthoScaleCB(Widget, XtPointer, XtPointer);
void	TrimPolygonCB(Widget, XtPointer, XtPointer);
void	TrimQuadraticCB(Widget, XtPointer, XtPointer);
void	TrimQuarticCB(Widget, XtPointer, XtPointer);
void	TrimQuinticCB(Widget, XtPointer, XtPointer);
void	TrimRangeCB(Widget, XtPointer, XtPointer);
void	TrimRmsCB(Widget, XtPointer, XtPointer);
void	TrimScaleExposeCB(Widget, XtPointer, XtPointer);
void	TrimScaleInitCB(Widget, XtPointer, XtPointer);
void	TrimSegmentsCB(Widget, XtPointer, XtPointer);
void	TrimSegmentUCB(Widget, XtPointer, XtPointer);
void	TrimSegmentVCB(Widget, XtPointer, XtPointer);
void	TrimSelfCB(Widget, XtPointer, XtPointer);
void	TrimShadedCB(Widget, XtPointer, XtPointer);
void	TrimSubSegmentUCB(Widget, XtPointer, XtPointer);
void	TrimSubSegmentVCB(Widget, XtPointer, XtPointer);
void	TrimSurfaceCB(Widget, XtPointer, XtPointer);
void    TrimSurfTryCB(Widget, XtPointer, XtPointer);
void	TrimToFacetCB(Widget, XtPointer, XtPointer);
void	TrimUnconstrainedCB(Widget, XtPointer, XtPointer);
void	TrimWireframeCB(Widget, XtPointer, XtPointer);
void	UnconDiagnosticCB(Widget, XtPointer, XtPointer);
void	Unconstrained2dCB(Widget, XtPointer, XtPointer);
void	UnconstrainedBladeCB(Widget, XtPointer, XtPointer);
void	UnconstrainedCB(Widget, XtPointer, XtPointer);
void    UnselectCB(Widget, XtPointer, XtPointer);
void 	UpdateContourMinMax(Widget, double);
void	UpdateContourValue(Widget, double);
void	UvAddCB(Widget, XtPointer, XtPointer);
void	UvCancelCB(Widget, XtPointer, XtPointer);
void	UvColorCB(Widget, XtPointer, XtPointer);
void	UvDeleteCB(Widget, XtPointer, XtPointer);
void	UvExposeCB(Widget, XtPointer, XtPointer);
void	UvInitCB(Widget, XtPointer, XtPointer);
void	UvInputCB(Widget, XtPointer, XtPointer);
void	UvInsertCB(Widget, XtPointer, XtPointer);
void	UvMoveCB(Widget, XtPointer, XtPointer);
void	UvOkCB(Widget, XtPointer, XtPointer);
void	UvPointsCB(Widget, XtPointer, XtPointer);
void	UvPolygonCB(Widget, XtPointer, XtPointer);
void	UvPtsToListCB(Widget, XtPointer, XtPointer);
void 	UvResetCB(Widget, XtPointer, XtPointer);
void	UvSelfCB(Widget, XtPointer, XtPointer);
void	UvSurfaceCB(Widget, XtPointer, XtPointer);
void	UvToleranceCB(Widget, XtPointer, XtPointer);
void    VectorSizeCB(Widget, XtPointer, XtPointer);
void	ViewCB(Widget, int, XtPointer);
void	ViewExposeCB(Widget, XtPointer, XtPointer);
void	ViewFunctionCB(Widget, int, XtPointer);
void	ViewGinitCB(Widget, XtPointer, XtPointer);
void	ViewIncrementsCB(Widget, XtPointer, XtPointer);
void	ViewPadDecCB(Widget, XtPointer, XtPointer);
void	ViewPadIncCB(Widget, XtPointer, XtPointer);
void	ViewPadTextCB(Widget, XtPointer, XtPointer);
void	WinsetWindow(Widget);
void	YesNoBoxCB(Widget, XtPointer, XtPointer);

#ifdef __cplusplus
}
#endif

#endif
